﻿namespace AccentColorApp
{
  using System.Reflection;

  using Xamarin.Forms;

  public partial class App : Application
  {
    public App()
    {
      this.InitializeComponent();

      // A pale violet red color which isn't used on any platform by default
      ApplyAccentColor(Color.FromHex("DB7093"));

      this.MainPage = new MainPage();
    }

    protected override void OnStart() { /* Handle when your app starts */ }

    protected override void OnSleep() { /* Handle when your app sleeps */ }

    protected override void OnResume() { /* Handle when your app resumes */ }

    private static void ApplyAccentColor(Color newAccentColor)
    {
      // Access the setter of the 'Xamarin.Forms.Color.Accent' property
      var prop = typeof(Color).GetRuntimeProperty(nameof(Color.Accent));
      var setter = prop?.SetMethod;
      // Invoke the setter method of the Color.Accent property to overwrite it with the custom accent color
      setter?.Invoke(Color.Accent, new object[] { newAccentColor });
    }
  }
}